\\ Start of Jug2.gp
\\ This PARI GP code file computes Juggler Sequences
\\ To run, start "C:\Program Files\PARI\gp.exe"
\\ with Start In: {where you keep your *.gp files}
\\ At Command: prompt, enter: \r Jug2
\\ Written by Harry J. Smith, 2008/08/28.

\\ See http://www.research.att.com/~njas/sequences/A094679
\\ A094679  n sets a new record for number of iterations to reach 1 in the juggler sequence problem.

digitsIn(x) = 1 + log(x)\log(10) \\ sizedigit(x) \\ #Str(x)
\\ Can be one too large if x is just under a power of 10
\\ Can be one too small if x is equal or just over a power of 10

{
  default(realprecision, 28);\
  allocatemem(800000000); \\ allocates a new stack of s bytes
  x0 = 1;
  x1 = 100000000;
  maxI = 0;
  maxX = 0;
  maxX0 = 0;
  maxOut = 1; \\ true
  fileRNew = 1;
  maxS = -1;
  maxS0 = 0;
  maxSOut = 1;
  fileSNew = 1;
  fileR = "JugR.Sum";
  fileS = "JugS.Sum";
  until (x0 > x1,
    print("Juggler Sequence started with x(0) = ", x0);
    if ((x0 == 1 || x0 % 2 == 0) && x0 > maxX,
      maxX = x0;    \\ if x0 is even and > max found so far
      maxI = 0;
      maxX0 = x0;
      maxOut = 0;
    );
    x = x0;
    s = 0;
    sm = 0;
    xm = x;
    while (x != 1,
      s++;
      print1(s);
      \\if (x < 100000000000000, print1(x, ","), print1("xxx,"));
      if (x % 2 == 0, print1("D"); x = sqrtint(x), print1("U"); x = sqrtint(x*x*x));
      digits = digitsIn(x);
      print1(" N=", digits);
      if (x == 1, print(), print1(", "));
      if (x > xm, xm = x; sm = s);
      if (x % 2 == 0 && x > maxX,
        maxX = x;
        maxI = s;
        maxX0 = x0;
        maxOut = 0;
      );
    );
    xmd = digitsIn(xm);
    print("x0 = ", x0, ", Digits in MaxX = ", xmd, ", Steps for MaxX = ", sm, ", Steps total = ", s);
    if (s > maxS,
      maxS = s;
      maxS0 = x0;
      maxSOut = 0;
    );
    if (maxOut == 0, \\ WriteMax
      if (fileRNew == 1,
        write(fileR, "-----------------------------------");
        fileRNew = 0;
      );
      digits = digitsIn(maxX);
      print("x(", maxI, ") max with ", digits, " digits for x(0) = ", maxX0);
      write(fileR, "x(", maxI, ") max with ", digits, " digits for x(0) = ", maxX0);
      maxOut = 1;
    );
    if (maxSOut == 0, \\ WriteMaxS
      if (fileSNew == 1,
        write(fileS, "-----------------------------------");
        fileSNew = 0;
      );
      print("Max steps = ", maxS, " for x0 = ", maxS0);
      write(fileS, "Max steps = ", maxS, " for x0 = ", maxS0);
      maxSOut = 1;
     );
    print();
    if (x0 == 1 || x0 % 2 == 0, x0++, x0 += 2);
  );
} \\ end of file Jug2.gp
